require "Window"
require "Apollo"


local NotNowMasterLoot = {}
local VILib, addonMasterLoot, addonSelf


function NotNowMasterLoot:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	return o
end

function NotNowMasterLoot:Init()
	Apollo.RegisterAddon(self, false, "", {"Viper:Lib:VILib-1.9"})
end

function NotNowMasterLoot:OnLoad()
	VILib = Apollo.GetPackage("Viper:Lib:VILib-1.9").tPackage

	self.xmlDoc = XmlDoc.CreateFromFile("NotNowMasterLoot.xml")
	self.xmlDoc:RegisterCallback("OnDocumentReady", self)
end

function NotNowMasterLoot:OnDocumentReady()
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
		self.wndMasterLootButton = Apollo.LoadForm(self.xmlDoc, "MasterLootButtonWindow", nil, self)
		if self.wndMasterLootButton == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
	end

	Apollo.RegisterEventHandler("WindowManagementReady", "OnWindowManagementReady", self)

	self.timerFlashUpdater = nil
	self.bFlashShown = false
	self.wndMasterLootButton:Show(false, true)
	self.wndMasterLootButton:FindChild("Flash"):SetOpacity(0, 100)

	addonMasterLoot = Apollo.GetAddon("MasterLoot")
	if addonMasterLoot then
		self.orgOnMasterLootUpdate = VILib:CopyTable(addonMasterLoot.OnMasterLootUpdate)
		addonMasterLoot.OnToggleGroupBag = self.OnToggleGroupBag
		addonMasterLoot.OnMasterLootUpdate = self.OnMasterLootUpdate
		addonSelf = self
		addonMasterLoot.wndMasterLoot:AddEventHandler("WindowHide", "OnMasterCloseWindow", addonSelf)
	end
end

function NotNowMasterLoot:OnWindowManagementReady()
	Event_FireGenericEvent("WindowManagementAdd", {wnd = self.wndMasterLootButton, strName = "Not Now Master Loot"})
end

function NotNowMasterLoot:OnToggleGroupBag()
	if addonMasterLoot.wndMasterLoot:IsVisible() then return end
	addonSelf.wndMasterLootButton:Show(true)
	addonSelf:SetButtonFlash()
end

function NotNowMasterLoot:OnMasterLootUpdate()
	if addonMasterLoot.wndMasterLoot:IsVisible() then return end
	addonSelf.wndMasterLootButton:Show(true)
	addonSelf:SetButtonFlash()
end

function NotNowMasterLoot:SetButtonFlash()
	if self.timerFlashUpdater then
		self.timerFlashUpdater:Stop()
		self.timerFlashUpdater = nil
	end
	self.timerFlashUpdater = ApolloTimer.Create(0.5, true, "SetButtonFlashOpacity", self)
end

function NotNowMasterLoot:SetButtonFlashOpacity()
	self.bFlashShown = not self.bFlashShown
	local nOpacity = 0
	if self.bFlashShown then nOpacity = 1 end
	self.wndMasterLootButton:FindChild("Flash"):SetOpacity(nOpacity, 2)
end

function NotNowMasterLoot:OnOpenMasterLootWindowButtonUp(wndHandler, wndControl, eMouseButton)
	addonMasterLoot.OnMasterLootUpdate = addonSelf.orgOnMasterLootUpdate
	addonMasterLoot:OnMasterLootUpdate(true)
	self.wndMasterLootButton:Show(false)
	if not self.timerWindowCheck then self.timerWindowCheck = ApolloTimer.Create(0.1, true, "OnWindowCheckTimer", self) end
end

function NotNowMasterLoot:OnWindowCheckTimer()
	if not addonMasterLoot.wndMasterLoot:IsVisible() then
		self.timerWindowCheck:Stop()
		self.timerWindowCheck = nil
		addonMasterLoot.OnMasterLootUpdate = self.OnMasterLootUpdate
	end
end



local NotNowMasterLootInst = NotNowMasterLoot:new()
NotNowMasterLootInst:Init()

